// SelectProcessDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ModifyMemory.h"
#include "SelectProcessDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <tlhelp32.h>

/////////////////////////////////////////////////////////////////////////////
// CSelectProcessDlg dialog


CSelectProcessDlg::CSelectProcessDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectProcessDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectProcessDlg)
	//}}AFX_DATA_INIT
}


void CSelectProcessDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectProcessDlg)
	DDX_Control(pDX, IDC_LIST_PROCESSES, m_lstCtrlProcesses);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectProcessDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectProcessDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectProcessDlg message handlers

BOOL CSelectProcessDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Init();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectProcessDlg::OnOK() 
{
	int  nSelectedItem			= m_lstCtrlProcesses.GetNextItem(-1, LVNI_SELECTED);
	m_strSelectedProcessName	= m_lstCtrlProcesses.GetItemText(nSelectedItem, 0);
	m_dwSelectedProcessID		= m_aryProcessID.GetAt(nSelectedItem);

	CDialog::OnOK();
}

void CSelectProcessDlg::Init()
{
	m_lstCtrlProcesses.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_lstCtrlProcesses.InsertColumn(0, "ӳ", LVCFMT_LEFT, 180 );
	
	HANDLE handle = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	PROCESSENTRY32 pe32;
 	pe32.dwSize = sizeof(pe32);

	BOOL	bRet		= FALSE;
 	DWORD	dwProcessID = 0;
	bRet = Process32First(handle, &pe32);
	while (FALSE != bRet)
	{
		m_lstCtrlProcesses.InsertItem(0, pe32.szExeFile);
		m_aryProcessID.InsertAt(0, pe32.th32ProcessID);
		bRet = Process32Next(handle, &pe32);
	}
	CloseHandle(handle);

	if (m_lstCtrlProcesses.GetItemCount() > 0)
	{
		m_lstCtrlProcesses.SetItemState(0, LVIS_SELECTED, LVIS_SELECTED);  
	}
}
