// ModifyMemoryDlg.h : header file
//

#if !defined(AFX_MODIFYMEMORYDLG_H__574BF6AA_B95E_4243_B9C2_7C6C4346EADF__INCLUDED_)
#define AFX_MODIFYMEMORYDLG_H__574BF6AA_B95E_4243_B9C2_7C6C4346EADF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ModifyMemory.h"
#include "SearchThread.h"

typedef struct tagSearchResult				// Ľ
{
	DWORD	dwAddress;						// ַ
	BYTE	pValue[SEARCH_STRING_MAX_LENGTH];
											// ֵַ
	char	nValueSize;						// ֵֽڳ
} SEARCH_RESULT;

/////////////////////////////////////////////////////////////////////////////
// CModifyMemoryDlg dialog

class CModifyMemoryDlg : public CDialog
{
// Construction
public:
	DWORD		m_dwProcessID;				// ID
	DWORD		m_dwMinAddress;				// ̵͵ַ				
	DWORD		m_dwMaxAddress;				// ̺ߵַ
	HANDLE		m_hProcess;					// ̾ 
	CPtrArray	m_aryResult;				// Ľ
	DWORD		m_dwReadCount;				// ĵַС
	int			*m_pThreadSeq;				// ̵߳
	int			m_nThreadActivateCount;		// ̸߳
	BOOL		m_bRunSearch;				// Ƿ
	CString		m_strTitle;					// ڱ
	BYTE		*m_pSearchMinBuf;			// ڴСֵ
	int			m_nMinBufSize;				// СֵС
	BYTE		*m_pSearchMaxBuf;			// ڴֵ
	int			m_nMaxBufSize;				// ֵС
	int			m_nSearchSize;				// ֵռڴĴС
	
	PSearchFunc	m_pSearchFunc;
							
	// ʱʼ
	void Init();

	// 򿪽
	BOOL OpenThread();

	// жֵǷʾ
	void RefreshSearchEdit();

	// ǷԵһ
	BOOL CanFirstSearch();

	// ǷԴӽ
	BOOL CanResultSearch();

public:
	CModifyMemoryDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CModifyMemoryDlg)
	enum { IDD = IDD_MODIFYMEMORY_DIALOG };
	CButton	m_btnUnicode;
	CComboBox	m_comboxSearchMode;
	CComboBox	m_comboxSearchType;
	CButton	m_btnInportFile;
	CButton	m_btnExportSelect;
	CButton	m_btnReSelectProcess;
	CButton	m_btnAdd;
	CButton	m_btnRefresh;
	CButton	m_btnCancelSelect;
	CButton	m_btnModifyNumber;
	CButton	m_btnSelectAll;
	CButton	m_btnResultSearch;
	CButton	m_btnFirstSearch;
	CListCtrl	m_lstCtrlResult;
	CProgressCtrl	m_ctlProSearch;
	CString	m_strAddress;
	CString	m_strModify;
	CString	m_strSearchMax;
	CString	m_strSearchMin;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CModifyMemoryDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
	virtual BOOL PreTranslateMessage(MSG* pMsg); 
	afx_msg LRESULT FindMemroyFunc(WPARAM, LPARAM);
	afx_msg LRESULT SearchProcessFunc(WPARAM, LPARAM);
	afx_msg LRESULT SearchFinishFunc(WPARAM, LPARAM);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CModifyMemoryDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonSearchFirst();
	afx_msg void OnButtonSearchResult();
	afx_msg void OnButtonSelectAll();
	afx_msg void OnButtonCancelSelect();
	afx_msg void OnButtonModifyNumber();
	afx_msg void OnClose();
	afx_msg void OnButtonRefresh();
	afx_msg void OnButtonAdd();
	afx_msg void OnButtonReselect();
	afx_msg void OnButtonExportSelect();
	afx_msg void OnButtonInportFile();
	afx_msg void OnSelchangeComboSearchMode();
	afx_msg void OnSelchangeComboSearchType();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MODIFYMEMORYDLG_H__574BF6AA_B95E_4243_B9C2_7C6C4346EADF__INCLUDED_)
