#ifndef _SEARCH_THREAD_H_
#define _SEARCH_THREAD_H_

#define PROCESS_SIZE				1000				// ֵ
#define THREAD_NUM					1					// ڴ̸߳

#define WM_FIND_MEMORY				(WM_USER + 1)		// ҵֵ
#define WM_FIND_PROGRESS			(WM_USER + 2)		// 
#define WM_SEARCH_FINISH			(WM_USER + 3)		// ߳

#define SEARCH_STRING_MAX_LENGTH	255					// ַ󳤶

class CModifyMemoryDlg;

// ̺߳
DWORD WINAPI SearchMemory(LPVOID lpParameter);

// ȷ
void EquSearch(CModifyMemoryDlg *pDlg, BYTE *lpBuf, MEMORY_BASIC_INFORMATION &mbi);

// 
void GreaterSearch(CModifyMemoryDlg *pDlg, BYTE *lpBuf, MEMORY_BASIC_INFORMATION &mbi);

// С
void SmallerSearch(CModifyMemoryDlg *pDlg, BYTE *lpBuf, MEMORY_BASIC_INFORMATION &mbi);

// Χ
void RangeSearch(CModifyMemoryDlg *pDlg, BYTE *lpBuf, MEMORY_BASIC_INFORMATION &mbi);

typedef void (*PSearchFunc)(CModifyMemoryDlg *pDlg, BYTE *lpBuf, MEMORY_BASIC_INFORMATION &mbi);

typedef enum 
{
	ENUM_SEARCH_CHAR,
	ENUM_SEARCH_2CHARS,
	ENUM_SEARCH_4CHARS,
	ENUM_SEARCH_8CHARS,
	ENUM_SEARCH_FLOAT,
	ENUM_SEARCH_DOUBLE,
	ENUM_SEARCH_STRING
} ENUM_SEARCH_TYPE;

typedef struct tagSearchType							// ֵ
{
	char			 *pTitle;
	char			 *pFormat;
	int				 nSize;
	ENUM_SEARCH_TYPE enumType;
} SEARCH_TYPE;

static SEARCH_TYPE searchType[] = 
{
	"ֽ",		"%d",		1,							ENUM_SEARCH_CHAR,
	"2 ֽ",	"%d",		2,							ENUM_SEARCH_2CHARS,
	"4 ֽ",	"%d",		4,							ENUM_SEARCH_4CHARS,
	"8 ֽ",	"%I64d",	8,							ENUM_SEARCH_8CHARS,
	"",	"%f",		4,							ENUM_SEARCH_FLOAT,
	"˫", "%lf",		8,							ENUM_SEARCH_DOUBLE,
	"ַ",	"%[^\0]s",	SEARCH_STRING_MAX_LENGTH,	ENUM_SEARCH_STRING
};

typedef enum
{
	ENUM_SEARCH_EQU,
	ENUM_SEARCH_GREATER,
	ENUM_SEARCH_SMALLER,
	ENUM_SEARCH_RANGE,
	ENUM_SEARCH_INCREASE,
	ENUM_SEARCH_DECREASE,
	ENUM_SEARCH_CHANGE
} ENUM_SEARCH_MODE;

typedef struct tagSearchMode						// ģʽ
{
	char			 *pTitle;
	ENUM_SEARCH_MODE enumMode;
	PSearchFunc		 pSearchFunc;
} SEARCH_MODE;

static SEARCH_MODE searchMode[] =
{
	"",			ENUM_SEARCH_EQU,		EquSearch,
	"",			ENUM_SEARCH_GREATER,	GreaterSearch,
	"С",			ENUM_SEARCH_SMALLER,	SmallerSearch,
	"֮",		ENUM_SEARCH_RANGE,		RangeSearch,
	"",			ENUM_SEARCH_INCREASE,	NULL,
	"С",			ENUM_SEARCH_DECREASE,	NULL,
	"仯",			ENUM_SEARCH_CHANGE,		NULL
};

#endif // end ifndef

